#procedure AdjustSum(i)
****************************************************************************
**
**  Filename:
**            AdjustSum.prc
**
**  Authors: 
**            Sven O. Moch and Peter Uwer
**
**  Purpose: 
**            Adjusts the sum boundaries. The argument specifies 
**            the index $i$ of the sum to be adjusted.
**
**  Comments:
**            This procedure is a modified version of a similiar procedure 
**            in the Summer package written by J.A.M. Vermaseren.
**
**  Revision: 
**            $Id: AdjustSum.prc,v 1.0 2005/08/02 10:09:54 puwer Exp $
**
**            $Log: AdjustSum.prc,v $
**            Revision 1.0  2005/08/02 10:09:54  puwer
**            Initial revision
**
**
****************************************************************************
*
#do icounter = `i',1,-1
	id  sum`i'(j`i',n1?,n2?) = sum`i'(j`i',n1,n2)*theta_(n2-n1);
	#call DoTheta(`icounter')
#enddo
#call DoTheta(0)

repeat;
	id sum`i'(j`i',x1?,x2?)*invfac`i'(x3?,-j`i') = f1(x1,x2,x3,x3-x2);
	if ( match(f1(?a,x4?pos0_)) == 0 );
		id f1(x1?,x2?,x3?,x4?) = sum`i'(j`i',x1,x2)*f3(x3,-j`i');
	endif;
endrepeat;

id f3(?a) = invfac`i'(?a);
id f1(x1?,x2?,x3?,0) = sum`i'(j`i',x1,x2)*invfac`i'(x3,-j`i');
id f1(x1?,x2?,x3?,n?) = sum`i'(j`i',x1,x3)*invfac`i'(x3,-j`i')
		-sum_(jjj,x2+1,x3,su(jjj))*invfac`i'(x3,-j`i');
id sum_(jjj,x1?,x2?,su(jjj)) = f1(x1,x2,x2-x1)*su(jjj);
repeat id f1(x1?,x2?,x3?pos_) = f1(x1,x2-1,x3-1)+replace_(jjj,x2);
id f1(x1?,x2?,0) = replace_(jjj,x2);
id f1(x1?,x2?,x3?neg_) = 0;
id f1(x1?,x2?,x3?)*su(jjj) = sum_(jjj,x1,x2,su(jjj));

if ( count(su,1) );
	id su(n?) = replace_(j`i',n);
	id S`i'(R(?a),X(?x),x1?,x2?) = S(R(?a),X(?x),x1+x2);
	id pow`i'(x1?,x2?,x3?) = pow(x1,x2+x3);
	id pow`i'(x1?,x2?) = pow(x1,x2);
	id den`i'(x1?,x2?) = den(x1+x2);
	id fac`i'(x1?,x2?) = fac(x1+x2);
	id invfac`i'(x1?,x2?) = invfac(x1+x2);
	id sign`i'(x?) = sign_(x);
	id fac(x?int_) = fac_(x);
	id invfac(x?int_) = invfac_(x);
	id den(x?pos_) = 1/x;
	id den(x?neg_) = 1/x;
	#call SubsS(0)
endif;

if ( match(den`i'(x1?pos_,j`i')) );
	id,once,den`i'(x1?pos_,j`i') = den`i'(x1,j`i')*XX(x1);
	#call Movej(`i',XX)
	id XX(x1?) = 1;
elseif ( match(den`i'(x1?neg_,j`i')) );
	id,once,den`i'(x1?neg_,j`i') = den`i'(x1,j`i')*XX(x1);
	#call Movej(`i',XX)
	id XX(x1?) = 1;
endif;

if ( match(den`i'(0,j`i')) );
	id sum`i'(j`i',n1?pos_,n2?) =
			sum`i'(j`i',1,n2) - sum_(jjj,1,n1-1,su(jjj));
	id sum_(jjj,x1?,x2?,su(jjj)) = f1(x1,x2,x2-x1)*su(jjj);
	repeat id f1(x1?,x2?,x3?pos_) = f1(x1,x2-1,x3-1)+replace_(jjj,x2);
	id f1(x1?,x2?,0) = replace_(jjj,x2);
	id f1(x1?,x2?,x3?neg_) = 0;
	id f1(x1?,x2?,x3?)*su(jjj) = sum_(jjj,x1,x2,su(jjj));
	if ( count(su,1) );
		id su(n?) = replace_(j`i',n);
		id S`i'(R(?a),X(?x),x1?,x2?) = S(R(?a),X(?x),x1+x2);
		id pow`i'(x1?,x2?,x3?) = pow(x1,x2+x3);
		id pow`i'(x1?,x2?) = pow(x1,x2);
		id den`i'(x1?,x2?) = den(x1+x2);
		id fac`i'(x1?,x2?) = fac(x1+x2);
		id invfac`i'(x1?,x2?) = invfac(x1+x2);
		id sign`i'(x?) = sign_(x);
		id fac(x?int_) = fac_(x);
		id invfac(x?int_) = invfac_(x);
		id den(x?pos_) = 1/x;
		id den(x?neg_) = 1/x;
		#call SubsS(0)
	endif;
elseif ( match(invfac`i'(n?int_,j`i')) || match(S`i'(R(?a),X(?x),n?int_,j`i'))
	|| match(fac`i'(n?int_,j`i')) );
	if ( match(invfac`i'(n?int_,j`i')) );
		id,once,invfac`i'(x1?int_,j`i') = invfac`i'(x1,j`i')*XX(x1);
	elseif ( match(fac`i'(n?int_,j`i')) );
		id,once,fac`i'(x1?int_,j`i') = fac`i'(x1,j`i')*XX(x1);
	else;
		id,once,S`i'(R(?a),X(?x),x1?int_,j`i') = S`i'(R(?a),X(?x),x1,j`i')*XX(x1)*
			theta`i'(x1,j`i');
	endif;
	#call Movej(`i',XX)
	id XX(x1?) = 1;
	SplitArg,(j`i'),theta`i';
	id theta`i'(x1?,x2?,j`i') = theta`i'(x1+x2,j`i');
	id sum`i'(j`i',n1?,n2?)*theta`i'(n3?,j`i') = 
		sum`i'(j`i',n1,n2)*theta_(n1-n3) + sum`i'(j`i',n3,n2)*theta_(n3-n1-1);
	if ( match(den`i'(0,j`i')) );
		id sum`i'(j`i',n1?pos_,n2?) =
				sum`i'(j`i',1,n2) - sum_(jjj,1,n1-1,su(jjj));
	else;
		id sum`i'(j`i',n1?pos_,n2?) =
				sum`i'(j`i',0,n2) - sum_(jjj,0,n1-1,su(jjj));
	endif;

	id sum_(jjj,x1?,x2?,su(jjj)) = f1(x1,x2,x2-x1)*su(jjj);
	repeat id f1(x1?,x2?,x3?pos_) = f1(x1,x2-1,x3-1)+replace_(jjj,x2);
	id f1(x1?,x2?,0) = replace_(jjj,x2);
	id f1(x1?,x2?,x3?neg_) = 0;
	id f1(x1?,x2?,x3?)*su(jjj) = sum_(jjj,x1,x2,su(jjj));

	if ( count(su,1) );
		id su(n?) = replace_(j`i',n);
		id S`i'(R(?a),X(?x),x1?,x2?) = S(R(?a),X(?x),x1+x2);
		id pow`i'(x1?,x2?,x3?) = pow(x1,x2+x3);
		id pow`i'(x1?,x2?) = pow(x1,x2);
		id den`i'(x1?,x2?) = den(x1+x2);
		id fac`i'(x1?,x2?) = fac(x1+x2);
		id invfac`i'(x1?,x2?) = invfac(x1+x2);
		id sign`i'(x?) = sign_(x);
		id fac(x?int_) = fac_(x);
		id invfac(x?int_) = invfac_(x);
		id den(x?pos_) = 1/x;
		id den(x?neg_) = 1/x;
		#call SubsS(0)
	endif;
endif;
if ( count(sum`i',1) );
  if ( match(invfac`i'(x1?,-j`i')) == 0 );
    if ( match(S`i'(R(?a),X(?x),x1?,-j`i')) );
      repeat;
        if ( count(XX,1) == 0 );
          id sum`i'(j`i',x1?,x2?)*S`i'(R(?a),X(?x),x3?,-j`i') =
            sum`i'(j`i',x1,x2)*f1(R(?a),X(?x),x3,-j`i')*XX(x3-x2);
          if ( match(XX(x?pos0_)) == 0 ) id XX(x?) = 1;
        endif;
      endrepeat;
      id  f1(?a) = S`i'(?a);
    elseif ( match(fac`i'(x1?,-j`i')) );
      repeat;
        if ( count(XX,1) == 0 );
          id sum`i'(j`i',x1?,x2?)*fac`i'(x3?,-j`i') =
            sum`i'(j`i',x1,x2)*f1(x3,-j`i')*XX(x3-x2);
          if ( match(XX(x?pos0_)) == 0 ) id XX(x?) = 1;
        endif;
      endrepeat;
      id  f1(?a) = fac`i'(?a);
    endif;
    id  XX(0) = 1;
    if ( count(XX,1) );
      id  sum`i'(j`i',x1?,x2?)*XX(x3?) =
        sum`i'(j`i',x1,x2+x3)-sum_(jjj,1,x3,su(x2+jjj));
      id  sum_(jjj,x1?,x2?,su(jjj)) = f1(x1,x2,x2-x1)*su(jjj);
      repeat id f1(x1?,x2?,x3?pos_) = f1(x1,x2-1,x3-1)+replace_(jjj,x2);
      id  f1(x1?,x2?,0) = replace_(jjj,x2);
      id  f1(x1?,x2?,x3?neg_) = 0;
      id  f1(x1?,x2?,x3?)*su(jjj) = sum_(jjj,x1,x2,su(jjj));
			if ( count(su,1) );
				id su(n?) = replace_(j`i',n);
				id S`i'(R(?a),X(?x),x1?,x2?) = S(R(?a),X(?x),x1+x2);
				id pow`i'(x1?,x2?,x3?) = pow(x1,x2+x3);
				id pow`i'(x1?,x2?) = pow(x1,x2);
				id den`i'(x1?,x2?) = den(x1+x2);
				id fac`i'(x1?,x2?) = fac(x1+x2);
				id invfac`i'(x1?,x2?) = invfac(x1+x2);
				id sign`i'(x?) = sign_(x);
				id fac(x?int_) = fac_(x);
				id invfac(x?int_) = invfac_(x);
				id den(x?pos_) = 1/x;
				id den(x?neg_) = 1/x;
				#call SubsS(0)
			endif;
    endif;
  endif;
endif;

id invfac`i'(0,j`i')*invfac`i'(x1?,-j`i') = bino`i'(x1,0,j`i')*invfac(x1);
id sum`i'(j`i',n1?{>1},n2?) = sum`i'(j`i',1,n2) - sum_(jjj,1,n1-1,su(jjj));

if ( count(su,1) );
  id su(n?) = replace_(j`i',n);
  id S`i'(R(?a),X(?x),x1?,x2?) = S(R(?a),X(?x),x1+x2);
  id pow`i'(x1?,x2?,x3?) = pow(x1,x2+x3);
  id pow`i'(x1?,x2?) = pow(x1,x2);
  id bino`i'(n?,j?) = fac(n)*invfac(n-j)*invfac(j);
  id den`i'(x1?,x2?) = den(x1+x2);
  id fac`i'(x1?,x2?) = fac(x1+x2);
  id invfac`i'(x1?,x2?) = invfac(x1+x2);
  id fac(x?int_) = fac_(x);
  id invfac(x?int_) = invfac_(x);
  id den(x?pos_) = 1/x;
  id den(x?neg_) = 1/x;
  #call SubsS(0)
endif;

id pow`i'(x1?,x2?,x3?) = pow`i'(x1,x2+x3);

*
* Cleanup pow`i'
*
SplitArg (j`i'),pow`i';
id pow`i'(x?,n1?,j`i') = pow(x,n1) * pow`i'(x,j`i');
id pow`i'(x?!{,0},n1?,-j`i') = pow(x,n1) * pow`i'(1/x,j`i');
repeat id pow`i'(x1?,j`i') * pow`i'(x2?,j`i') = pow`i'(x1*x2,j`i');

id pow(0,x?) = 0;
id pow(1,x?) = 1;
id pow(x?,0) = 1;
id pow`i'(0,x?) = 0;
id pow`i'(1,x?) = 1;
id pow`i'(x?,0) = 1;
id pow`i'(x1?,j?!{,j`i'}) = pow(x1,j);

#endprocedure
*************************************************************************
* Local variables:
* modify-insert-tag: nil
* comment-start: "*"
* tab-width: 2
* End:
*************************************************************************
