#procedure RegSum(i)
****************************************************************************
**
**  Filename:
**            RegSum.prc
**
**  Authors: 
**            Sven O. Moch and Peter Uwer
**
**  Purpose: 
**            Performs final regularization of a sum. The argument specifies 
**            the index $i$ of the sum to be regularized.
**
**  Comments:
**
**
**  Revision: 
**            $Id: RegSum.prc,v 1.0 2005/08/02 10:09:54 puwer Exp $
**
**            $Log: RegSum.prc,v $
**            Revision 1.0  2005/08/02 10:09:54  puwer
**            Initial revision
**
**
****************************************************************************
*
if ( count(bino`i',1) == 0 );
	id  sum`i'(j`i',x1?,x2?)*den`i'(x3?,-j`i') =
		XX(x3-x2)*sum`i'(j`i',x1,x2)*den`i'(x3,-j`i');
	if ( count(XX,1) );
		#call Flipj(`i')
		id  XX(x1?) = 1;
		#call SynchDenS(`i')
	endif;
endif;
.sort: RegSumFlipDir;
if ( match(den`i'(x1?!{0,0},j`i')) );
	id,once,den`i'(x1?,j`i') = den`i'(x1,j`i')*XX(x1);
	#call Movej(`i',XX)
endif;
id  XX(x1?) = 1;
.sort:RegSumShiftDen`i';
id  sum`i'(j`i',x1?,x2?)*den`i'(x3?,-j`i') =
        XX(x3-x2)*sum`i'(j`i',x1,x2)*den`i'(x3,-j`i');
if ( count(XX,1) );
        #call Flipj(`i')
endif;
id  XX(x1?) = 1;
.sort:RegSumFlipDir;
if ( count(bino`i',1) == 0 );
    if ( match(den`i'(x1?!{0,0},j`i')) );
        id,once,den`i'(x1?,j`i') = den`i'(x1,j`i')*XX(x1);
        #call Movej(`i',XX)
        id  XX(x1?) = 1;
    endif;
endif;
.sort:RegSumShiftDen`i';

#do ni = `i'-1,1,-1
	id  sum`i'(j`i',n1?,n2?) = sum`i'(j`i',n1,n2)*theta_(n2-n1);
	#call DoTheta(`ni')
#enddo
#call DoTheta(0)
repeat;
	id  sum`i'(j`i',0,n?pos_) = sum`i'(j`i',0,n-1)+replace_(j`i',n);
endrepeat;
id  sum`i'(j`i',0,0) = replace_(j`i',0);
id  sum`i'(j`i',0,n?neg_) = 0;

if ( match(den`i'(0,j`i')) );
	id  sum`i'(j`i',n1?pos_,n2?) =
		sum`i'(j`i',1,n2) - sum_(jjj,1,n1-1,su(jjj));
endif;
id  sum_(jjj,x1?,x2?,su(jjj)) = f1(x1,x2,x2-x1)*su(jjj);
repeat id f1(x1?,x2?,x3?pos_) = f1(x1,x2-1,x3-1)+replace_(jjj,x2);
id  f1(x1?,x2?,0) = replace_(jjj,x2);
id  f1(x1?,x2?,x3?neg_) = 0;
id  f1(x1?,x2?,x3?)*su(jjj) = sum_(jjj,x1,x2,su(jjj));

if ( count(su,1) );
	id  su(n?) = replace_(j`i',n);
	id  S`i'(R(?a),X(?x),x1?,x2?) = S(R(?a),X(?x),x1+x2);
	id 	pow`i'(x1?,x2?,x3?) = pow(x1,x2+x3);
	id 	pow`i'(x1?,x2?) = pow(x1,x2);
	id  bino`i'(n1?,n2?,n3?) = fac(n1)*invfac(n2+n3)*invfac(n1-n2-n3);
	id  den`i'(x1?,x2?) = den(x1+x2);
	id  fac`i'(x1?,x2?) = fac(x1+x2);
	id  invfac`i'(x1?,x2?) = invfac(x1+x2);
	id  fac(x?int_) = fac_(x);
	id  invfac(x?int_) = invfac_(x);

	id  den(x?pos_) = 1/x;
	id  den(x?neg_) = 1/x;
	#call SubsS(0)
endif;
*
*   final introduction of binomial coefficients.
*
if ( count(fac`i',1,invfac`i',1) >= 2 );
	id  invfac`i'(n1?,j`i')*invfac`i'(n2?,-j`i') =
		bino`i'(n1+n2,n1,j`i')*invfac(n1+n2);
	id  fac`i'(n1?,j`i')*invfac`i'(n2?,j`i') =
		bino`i'(n1,j`i',n2,j`i')*fac(n1-n2);
endif;
#endprocedure
*************************************************************************
* Local variables:
* modify-insert-tag: nil
* comment-start: "*"
* tab-width: 2
* End:
*************************************************************************
